<?php
/*****************************************************************************/
/* SplitThreads.php                                                          */
/*****************************************************************************/
/* YaBB: Yet another Bulletin Board                                          */
/* Open-Source Project started by Zef Hemel (zef@zefnet.com)                 */
/* Software Version: YaBB SE                                                 */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/*                             http://www.yabbforum.com/community            */
/* ========================================================================= */
/* Copyright (c) 2001-2002 The YaBB SE Development Team                      */
/* Software by: The YaBB SE Development Team                                 */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/
/* Original module by Mach8                                                  */
/*****************************************************************************/

$splitthreadsphpver = 'YaBB SE 1.5.0';

function SplitThreads()
{
	global $thread, $at, $sc, $username, $yytitle, $moderators, $settings, $txt;
	global $currentboard, $color, $cgi, $threadid, $ubbcjspath, $db_prefix, $from, $subname;
	
	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt['yse253']);

	if (!is_numeric($thread) || !is_numeric($at))
		fatal_error($txt[337]);

	// retrieve subject of the specific topic
	$request = mysql_query("SELECT subject FROM {$db_prefix}messages WHERE ID_MSG=$at AND ID_TOPIC=$thread");
	$row = mysql_fetch_array($request);
	$subname = $row['subject'];

	// check if there is more than one message in the topic
	$request = mysql_query("SELECT COUNT(*) AS numMessages FROM {$db_prefix}messages WHERE ID_TOPIC=$thread");
	$row = mysql_fetch_array($request);
	if ($row['numMessages'] < 2)
		fatal_error($txt['yse270']);

	// Check if this is the first message in the topic (if so, the first and second option won't be available)
	$request = mysql_query("SELECT ID_FIRST_MSG FROM {$db_prefix}topics WHERE ID_TOPIC=$thread");
	$row = mysql_fetch_array($request);
	if ($row['ID_FIRST_MSG'] == $at)
		SplitThreads3();

	
	$yytitle = $txt['yse251'];
	template_header();

	echo '
		<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt['yse251'] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="center">
					<form action="' . $cgi . ';action=splitthreads2" method="post">
						<input type="hidden" name="thread" value="' . $thread . '" />
						<input type="hidden" name="at" value="' . $at . '" /><br />
						<table border="0">
							<tr>
								<td>
									<b>' . $txt['yse254'] . '</b> <input type="text" name="subname" value="' . $subname . '" /><br /><br />
									<input type="radio" name="step2" value="onlythis" checked="checked" /> ' . $txt['yse255'] . '<br />
									<input type="radio" name="step2" value="afterthis" /> ' . $txt['yse256'] . '<br />
									<input type="radio" name="step2" value="selective" /> ' . $txt['yse257'] . '<br />
								</td>
							</tr><tr>
								<td>
									<br /><input type="submit" value="' . $txt['yse251'] . '" />
								</td>
							</tr>
						</table>
						<input type="hidden" name="sc" value="' . $sc . '" />
					</form>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

function SplitThreads2() 
{
	global $username, $moderators, $settings, $txt, $currentboard, $threadid, $scripturl, $toboard, $yySetLocation;
	global $db_prefix, $reason, $ID_MEMBER, $realemail, $REMOTE_ADDR, $board, $doLimitOne, $postRedirect, $cgi;
	global $thread, $at, $subname, $step2, $yytitle, $color;

	checkSession();

	if ($subname == '')
		$subname = $txt['yse258'];
	
	if (!is_numeric($thread) || !is_numeric($at))
		fatal_error($txt[337]);

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt['yse253']);

	$split1_topicID = $thread;
	$split2_firstMsg = $at;
	$split2_firstMem = getMemberID($split2_firstMsg);

	$tresult = mysql_query("
		SELECT MIN(m.ID_MSG) AS myID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, COUNT(m.ID_MSG) - 1 as myNumReplies
		FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m
		WHERE m.ID_TOPIC=t.ID_TOPIC
			AND t.ID_TOPIC=$split1_topicID
		GROUP BY t.ID_TOPIC");
	$row = mysql_fetch_array($tresult);
	$split1_firstMsg = $row['myID_FIRST_MSG'];
	$split1_firstMem = getMemberID($split1_firstMsg);
	$orig_lastMsg = $row['myID_LAST_MSG'];
	$orig_lastMem = getMemberID($orig_lastMsg);
	$orig_replies = $row['myNumReplies'];

	if ($at == $split1_firstMsg && $step2 != 'selective')
		fatal_error($txt['yse268']);

 	if ($step2 == 'selective')
	{
		$yySetLocation = "$cgi;action=splitthreads3;thread=$thread;subname=$subname";
		redirectexit();
	}
	elseif ($step2 == 'afterthis' || ($step2 == 'onlythis' && $orig_lastMsg == $split2_firstMsg)) 
	{
		$split2_lastMsg = $orig_lastMsg;
		$split2_lastMem = $orig_lastMem;
	
		$request = mysql_query("
			SELECT m.ID_MSG, IFNULL(mem.ID_MEMBER,-1) AS myID_MEMBER
			FROM {$db_prefix}messages AS m
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
			WHERE ID_TOPIC=$split1_topicID 
				AND ID_MSG<$at 
			ORDER BY ID_MSG DESC
			LIMIT 1");

		$row = mysql_fetch_array($request);
		$split1_lastMsg = $row['ID_MSG'];
		$split1_lastMem = $row['myID_MEMBER'];

		$request = mysql_query("SELECT COUNT(*) - 1 AS numReplies FROM {$db_prefix}messages WHERE ID_TOPIC=$split1_topicID AND ID_MSG>=$at");
		$row = mysql_fetch_array($request);
		$split2_replies = $row['numReplies'];
		$split1_replies = $orig_replies - $split2_replies - 1;
		
	}
	elseif ($step2 == 'onlythis')
	{
		$split1_lastMsg = $orig_lastMsg;
		$split1_lastMem = $orig_lastMem;
		$split2_lastMsg = $split2_firstMsg;
		$split2_lastMem = $split2_firstMem;
		$split2_replies = 0;
		$split1_replies = $orig_replies - 1;
	}
	else
		fatal_error('hacker?');

	// no db changes at this point yet, so let's double check to see if everything's ok
	if ($split1_firstMsg <= 0 || $split1_lastMsg <= 0 || $split2_firstMsg <= 0 || $split2_lastMsg <= 0 || $split1_replies < 0 || $split2_replies < 0)
		fatal_error($txt['yse272']);

	$request = mysql_query("
		INSERT INTO {$db_prefix}topics (ID_BOARD,ID_MEMBER_STARTED,ID_MEMBER_UPDATED,ID_FIRST_MSG,ID_LAST_MSG,numReplies) 
		VALUES ($board,$split2_firstMem,$split2_firstMem,$split2_firstMsg,$split2_lastMsg,$split2_replies)");
	$split2_topicID = mysql_insert_id();
	if ($split2_topicID <= 0)
		fatal_error($txt['yse273']);

	$result = mysql_query("UPDATE {$db_prefix}messages SET ID_TOPIC=$split2_topicID WHERE ID_TOPIC=$split1_topicID AND ID_MSG>=$split2_firstMsg AND ID_MSG<=$split2_lastMsg");
	$result = mysql_query("UPDATE {$db_prefix}messages SET subject='$subname' WHERE ID_MSG=$at AND ID_TOPIC=$split2_topicID");

	$request = mysql_query("
		UPDATE {$db_prefix}topics 
		SET ID_FIRST_MSG=$split1_firstMsg, ID_LAST_MSG=$split1_lastMsg, ID_MEMBER_STARTED=$split1_firstMem, ID_MEMBER_UPDATED=$split1_lastMem, numReplies=$split1_replies
		WHERE ID_TOPIC=$split1_topicID");

	updateStats('topic');
	updateLastMessage($board);

	$yytitle = $txt['yse251'];
	template_header();
	echo '
		<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt['yse251'] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="center">
					<font size="2">
						' . $txt['yse259'] . '<br /><br />
						<a href="' . $cgi . '">' . $txt[101] . '</a><br />
						<a href="' . $cgi . ';action=display;threadid=' . $split1_topicID . '">' . $txt['yse260'] . '</a><br />
						<a href="' . $cgi . ';action=display;threadid=' . $split2_topicID . '">' . $txt['yse258'] . '</a>
					</font>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

function SplitThreads3()
{
	global $username, $moderators, $settings, $txt, $currentboard, $threadid, $scripturl, $yySetLocation;
	global $db_prefix, $reason, $ID_MEMBER, $realemail, $REMOTE_ADDR, $board, $doLimitOne, $postRedirect, $cgi;
	global $yytitle, $thread, $subname, $color, $sc;

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt['yse253']);

	$yytitle = "$txt[yse251] - $txt[yse257]";
	template_header();
	echo '
		<form action="' . $cgi . ';action=splitthreads4" method="post"><input type="hidden" name="thread" value="' . $thread . '" />
			<table border="0" width="80%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[yse251] . ' - ' . $txt[yse257] . '</b></font>
					</td>
				</tr><tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle">
						<font size="2">' . $txt['yse261'] . '</font>
					</td>
				</tr>';
	
	$tresult = mysql_query("SELECT subject,posterName,body,ID_MSG FROM {$db_prefix}messages WHERE ID_TOPIC=$thread ORDER BY ID_MSG ASC");
	while ($row = mysql_fetch_array($tresult))
	{
		$mbody = $row['body'];
		$mbody = doUBBC($mbody);
		$sub = $row['subject'];
		$poster = $row['posterName'];
		$boxname = "selpost_".$row['ID_MSG'];
		echo '
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle">
						<font size="1">
							<input type="checkbox" name="' . $boxname . '" /> ' . $sub . ' - ' . $poster . '<br />
							' . $mbody . '
						</font>
					</td>
				</tr>';
	}
	echo '
			</table>
			<p align="center">
				<input type="hidden" name="subname" value="' . $subname . '" />
				<input type="submit" value="' . $txt['yse251'] . '" />
			</p>
			<input type="hidden" name="sc" value="' . $sc . '" />
		</form>';
	footer();
	obExit();
}

function SplitThreads4()
{
	global $yytitle, $cgi, $board, $old, $new, $thread, $selpost, $subname, $db_prefix;
	global $HTTP_POST_VARS, $color, $txt, $moderators, $settings, $username;

	checkSession();

	if ($subname == '')
		$subname = $txt['yse258'];

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt['yse253']);

	if (!is_numeric($thread))
		fatal_error($txt[337]);
	
	$split1_topicID = $thread;

	$posts = array();
	foreach ($HTTP_POST_VARS as $postVar => $postVarValue)
		if (strcmp(substr($postVar, 0, 8), 'selpost_') == 0 && is_numeric(substr($postVar, 8)))
			$posts[] = substr($postVar, 8);
	
	if (count($posts) == 0)
		fatal_error($txt['yse271']);

	$postList = implode(',', $posts);

	$result = mysql_query("
		SELECT MIN(m.ID_MSG) AS myID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, COUNT(m.ID_MSG) - 1 AS myNumReplies
		FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t
		WHERE m.ID_MSG NOT IN ($postList)
			AND m.ID_TOPIC=t.ID_TOPIC
			AND t.ID_TOPIC=$split1_topicID 
		GROUP BY t.ID_TOPIC ASC LIMIT 1");
	if (mysql_num_rows($result) == 0)
		fatal_error($txt['yse271b']); //the user has probably selected everything
	$row = mysql_fetch_array($result);
	$split1_firstMsg = $row['myID_FIRST_MSG'];
	$split1_firstMem = getMemberID($split1_firstMsg);
	$split1_lastMsg = $row['myID_LAST_MSG'];
	$split1_lastMem = getMemberID($split1_lastMsg);
	$split1_replies = $row['myNumReplies'];

	$result = mysql_query("
		SELECT MIN(m.ID_MSG) AS myID_FIRST_MSG, MAX(m.ID_MSG) AS myID_LAST_MSG, COUNT(m.ID_MSG) - 1 AS myNumReplies
		FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t
		WHERE m.ID_MSG IN ($postList)
			AND m.ID_TOPIC=t.ID_TOPIC
			AND t.ID_TOPIC=$split1_topicID 
		GROUP BY t.ID_TOPIC ASC LIMIT 1");
	$row = mysql_fetch_array($result);
	$split2_firstMsg = $row['myID_FIRST_MSG'];
	$split2_firstMem = getMemberID($split1_firstMsg);
	$split2_lastMsg = $row['myID_LAST_MSG'];
	$split2_lastMem = getMemberID($split1_lastMsg);
	$split2_replies = $row['myNumReplies'];

	// no db changes at this point yet, so let's double check to see if everything's ok
	if ($split1_firstMsg <= 0 || $split1_lastMsg <= 0 || $split2_firstMsg <= 0 || $split2_lastMsg <= 0 || $split1_replies < 0 || $split2_replies < 0)
		fatal_error($txt['yse272']);
	
	// everything's ok, let's start to insert
	$request = mysql_query("
		INSERT INTO {$db_prefix}topics (ID_BOARD,ID_MEMBER_STARTED,ID_MEMBER_UPDATED,ID_FIRST_MSG,ID_LAST_MSG, numReplies) 
		VALUES ($board, $split2_firstMem, $split2_lastMem, $split2_firstMsg, $split2_lastMsg, $split2_replies)");
	$split2_topicID = mysql_insert_id();
	if ($split2_topicID <= 0)
		fatal_error($txt['yse273']);
	
	$result = mysql_query("UPDATE {$db_prefix}messages SET ID_TOPIC=$split2_topicID,subject='$subname' WHERE ID_TOPIC=$split1_topicID AND ID_MSG IN ($postList)");

	$request = mysql_query("
		UPDATE {$db_prefix}topics 
		SET numReplies=$split1_replies, ID_FIRST_MSG=$split1_firstMsg, ID_MEMBER_STARTED=$split1_firstMem, ID_LAST_MSG=$split1_lastMsg, ID_MEMBER_UPDATED=$split1_lastMem
		WHERE ID_TOPIC=$split1_topicID");

	$tresult = mysql_query("UPDATE {$db_prefix}boards SET numTopics=numTopics+1 WHERE ID_BOARD=$board");
	
	updateStats('topic');
	updateLastMessage($board);
	
	$yytitle = $txt['yse251'];
	template_header();
	echo '
		<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt['yse251'] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="center">
					<font size="2">
						' . $txt['yse259'] . '<br /><br />
						<a href="' . $cgi . '">' . $txt[101] . '</a><br />
						<a href="' . $cgi . ';action=display;threadid=' . $split1_topicID . '">' . $txt['yse260'] . '</a><br />
						<a href="' . $cgi . ';action=display;threadid=' . $split2_topicID . '">' . $txt['yse258'] . '</a>
					</font>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}
?>